<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8">
<link rel="stylesheet" href="style_while.css" type="text/css">
<title>semantics_simplified.html</title>
</head>
<body>
<div class="why3doc">
<pre><span class="keyword">module</span> <a name="Aexp_">Aexp</a>

  <span class="keyword">use</span> <span class="keyword">export</span> fmap.Fmap
  <span class="keyword">use</span> <span class="keyword">export</span> int.<a href="int.html#Int_">Int</a>
  <span class="keyword">use</span> <span class="keyword">export</span> bool.<a href="bool.html#Bool_">Bool</a>

  <span class="keyword">type</span> <a name="var_7">var</a>

  <span class="keyword">type</span> <a name="a_op_10">a_op</a> =
	  | <a name="PLUS_11">PLUS</a>
	  | <a name="MULT_12">MULT</a>
	  | <a name="MINUS_13">MINUS</a>

  <span class="keyword">type</span> <a name="a_exp_15">a_exp</a> =
	  | <a name="Int_e_16">Int_e</a> int
	  | <a name="Var_e_17">Var_e</a> <a href="#var_7">var</a>
	  | <a name="Minus_e_18">Minus_e</a> a_exp
	  | <a name="Op_e_19">Op_e</a> a_exp <a href="#a_op_10">a_op</a> a_exp

	<span class="keyword">type</span> <a name="state_21">state</a> = <a href="fmap.html#fmap_27">fmap</a> <a href="#var_7">var</a> int

	<span class="keyword">function</span> <a name="a_exp_eval_24">a_exp_eval</a> (aexp: <a href="#a_exp_15">a_exp</a>) (s: <a href="#state_21">state</a>) : int
	= <span class="keyword">match</span> aexp <span class="keyword">with</span>
	| <a href="#Int_e_16">Int_e</a> n -&gt; n
	| <a href="#Var_e_17">Var_e</a> x -&gt; <a href="fmap.html#find_83">find</a> x s
	| <a href="#Minus_e_18">Minus_e</a> a1 -&gt; 0 <a href="int.html#infix%20-_23">-</a> <a href="#a_exp_eval_24">a_exp_eval</a> a1 s
	| <a href="#Op_e_19">Op_e</a> a1 <a href="#PLUS_11">PLUS</a> a2 -&gt; <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20+_19">+</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s
	| <a href="#Op_e_19">Op_e</a> a1 <a href="#MULT_12">MULT</a> a2 -&gt; <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20*_20">*</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s
	| <a href="#Op_e_19">Op_e</a> a1 <a href="#MINUS_13">MINUS</a> a2 -&gt; <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20-_23">-</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s
	<span class="keyword">end</span>

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Bexp_">Bexp</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Aexp_">Aexp</a>

  <span class="comment">(* Operations *)</span>

  <span class="keyword">type</span> <a name="b_aexp_op_43">b_aexp_op</a> =
	  | <a name="EQUAL_44">EQUAL</a>
	  | <a name="LE_45">LE</a>

  <span class="keyword">type</span> <a name="b_bexp_binary_op_47">b_bexp_binary_op</a> =
	  | <a name="AND_48">AND</a>

  <span class="keyword">type</span> <a name="b_bexp_unary_op_50">b_bexp_unary_op</a> =
	  | <a name="NOT_51">NOT</a>

  <span class="comment">(* Expressions *)</span>

  <span class="keyword">type</span> <a name="b_exp_55">b_exp</a> =
	  | <a name="B_e_56">B_e</a> bool
	  | <a name="B_aexp_e_57">B_aexp_e</a> <a href="#a_exp_15">a_exp</a> <a href="#b_aexp_op_43">b_aexp_op</a> <a href="#a_exp_15">a_exp</a>
	  | <a name="B_un_e_58">B_un_e</a> <a href="#b_bexp_unary_op_50">b_bexp_unary_op</a> b_exp
	  | <a name="B_bin_e_59">B_bin_e</a> b_exp <a href="#b_bexp_binary_op_47">b_bexp_binary_op</a> b_exp

	<span class="keyword">function</span> <a name="b_exp_eval_61">b_exp_eval</a> (bexp: <a href="#b_exp_55">b_exp</a>) (s: <a href="#state_21">state</a>) : bool
	= <span class="keyword">match</span> bexp <span class="keyword">with</span>
	  | <a href="#B_e_56">B_e</a> b  -&gt; b
	  | <a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#EQUAL_44">EQUAL</a> a2 -&gt; <span class="keyword">if</span> <a href="#a_exp_eval_24">a_exp_eval</a> a1 s = <a href="#a_exp_eval_24">a_exp_eval</a> a2 s <span class="keyword">then</span> True <span class="keyword">else</span> False
	  | <a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#LE_45">LE</a> a2 -&gt; <span class="keyword">if</span> <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s <span class="keyword">then</span> True <span class="keyword">else</span> False
	  | <a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b -&gt; <span class="keyword">if</span> <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s <span class="keyword">then</span> True <span class="keyword">else</span> False
	  | <a href="#B_bin_e_59">B_bin_e</a> b1 <a href="#AND_48">AND</a> b2 -&gt; <span class="keyword">if</span> (<a href="#b_exp_eval_61">b_exp_eval</a> b1 s &amp;&amp; <a href="#b_exp_eval_61">b_exp_eval</a> b2 s) <span class="keyword">then</span> True <span class="keyword">else</span> False
  <span class="keyword">end</span>

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="While_">While</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Bexp_">Bexp</a>

	<span class="keyword">type</span> <a name="stm_76">stm</a> =
    | <a name="ASSIGN_77">ASSIGN</a> <a href="#var_7">var</a> <a href="#a_exp_15">a_exp</a>
    | <a name="SKIP_78">SKIP</a>
    | <a name="COMP_79">COMP</a> stm stm
    | <a name="IF_80">IF</a> <a href="#b_exp_55">b_exp</a> stm stm
    | <a name="WHILE_81">WHILE</a> <a href="#b_exp_55">b_exp</a> stm

  <span class="keyword">type</span> <a name="res_state_83">res_state</a> =
    | <a name="Undef_84">Undef</a>
    | <a name="Res_85">Res</a> <a href="#state_21">state</a>

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="While_ext_">While_ext</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#Bexp_">Bexp</a>

	<span class="keyword">type</span> <a name="stm_93">stm</a> =
    | <a name="ASSIGN_94">ASSIGN</a> <a href="#var_7">var</a> <a href="#a_exp_15">a_exp</a>
    | <a name="SKIP_95">SKIP</a>
    | <a name="COMP_96">COMP</a> stm stm
    | <a name="IF_97">IF</a> <a href="#b_exp_55">b_exp</a> stm stm
    | <a name="WHILE_98">WHILE</a> <a href="#b_exp_55">b_exp</a> stm
    | <a name="REPEAT_99">REPEAT</a> stm <a href="#b_exp_55">b_exp</a>

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Big_step_">Big_step</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#While_">While</a>

  <span class="keyword">inductive</span> (<a name="infix%20--%3E_107">--&gt;</a>) <a href="#stm_76">stm</a> <a href="#state_21">state</a> <a href="#state_21">state</a> =
    | <a name="ass_ns_108">ass_ns</a> : <span class="keyword">forall</span> x: <a href="#var_7">var</a>, a: <a href="#a_exp_15">a_exp</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#ASSIGN_77">ASSIGN</a> x a) s (<a href="fmap.html#add_65">add</a> x (<a href="#a_exp_eval_24">a_exp_eval</a> a s) s)
    | <a name="skip_ns_110">skip_ns</a> : <span class="keyword">forall</span> s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_107">--&gt;</a>) <a href="#SKIP_78">SKIP</a> s s
    | <a name="comp_ns_112">comp_ns</a> : <span class="keyword">forall</span> stm1 stm2: <a href="#stm_76">stm</a>, s s' s'': <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_107">--&gt;</a>) stm1 s s' -&gt;
            (<a href="#infix%20--%3E_107">--&gt;</a>) stm2 s' s'' -&gt;
              (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#COMP_79">COMP</a> stm1 stm2) s s''
    | <a name="if_tt_ns_116">if_tt_ns</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_76">stm</a>, s s': <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_107">--&gt;</a>) stm1 s s' -&gt;
              (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#IF_80">IF</a> b stm1 stm2) s s'
    | <a name="if_ff_ns_120">if_ff_ns</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_76">stm</a>, s s': <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_107">--&gt;</a>) stm2 s s' -&gt;
              (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#IF_80">IF</a> b stm1 stm2) s s'
    | <a name="while_tt_ns_124">while_tt_ns</a> : <span class="keyword">forall</span> b:<a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_76">stm</a>, s s' s'': <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt;
              (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> b stm) s' s'' -&gt;
                (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> b stm) s s''
    | <a name="while_ff_ns_129">while_ff_ns</a> : <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_76">stm</a>, s: <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> b stm) s s

  <span class="keyword">lemma</span> <a name="example_2_1_1_134">example_2_1_1</a>: <span class="keyword">forall</span> x y z.
    x &lt;&gt; y -&gt; x &lt;&gt; z -&gt; y &lt;&gt; z -&gt;
      (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#COMP_79">COMP</a> (<a href="#ASSIGN_77">ASSIGN</a> z (<a href="#Var_e_17">Var_e</a> x)) (<a href="#ASSIGN_77">ASSIGN</a> x (<a href="#Var_e_17">Var_e</a> y))) (<a href="fmap.html#add_65">add</a> x 5 (<a href="fmap.html#add_65">add</a> y 7 (<a href="fmap.html#empty_61">empty</a>: <a href="fmap.html#fmap_27">fmap</a> <a href="#var_7">var</a> int))) (<a href="fmap.html#add_65">add</a> x 7 (<a href="fmap.html#add_65">add</a> z 5 (<a href="fmap.html#add_65">add</a> x 5 (<a href="fmap.html#add_65">add</a> y 7 (<a href="fmap.html#empty_61">empty</a>: <a href="fmap.html#fmap_27">fmap</a> <a href="#var_7">var</a> int)))))

  <span class="keyword">lemma</span> <a name="example_2_1_2_139">example_2_1_2</a>: <span class="keyword">forall</span> x y z.
    x &lt;&gt; y -&gt; x &lt;&gt; z -&gt; y &lt;&gt; z -&gt;
      (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#ASSIGN_77">ASSIGN</a> y (<a href="#Var_e_17">Var_e</a> z)) (<a href="fmap.html#add_65">add</a> z 5 (<a href="fmap.html#add_65">add</a> x 7 (<a href="fmap.html#add_65">add</a> y 7 (<a href="fmap.html#empty_61">empty</a>: <a href="fmap.html#fmap_27">fmap</a> <a href="#var_7">var</a> int)))) (<a href="fmap.html#add_65">add</a> y 5 (<a href="fmap.html#add_65">add</a> z 5 (<a href="fmap.html#add_65">add</a> x 7 (<a href="fmap.html#add_65">add</a> y 7 (<a href="fmap.html#empty_61">empty</a>: <a href="fmap.html#fmap_27">fmap</a> <a href="#var_7">var</a> int)))))

  <span class="keyword">lemma</span> <a name="example_2_1_143">example_2_1</a>: <span class="keyword">forall</span> x y z.
    x &lt;&gt; y -&gt; x &lt;&gt; z -&gt; y &lt;&gt; z -&gt;
      <span class="keyword">let</span> s = (<a href="fmap.html#add_65">add</a> x 5 (<a href="fmap.html#add_65">add</a> y 7 <a href="fmap.html#empty_61">empty</a>)) <span class="keyword">in</span>
        (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#COMP_79">COMP</a> (<a href="#COMP_79">COMP</a> (<a href="#ASSIGN_77">ASSIGN</a> z (<a href="#Var_e_17">Var_e</a> x)) (<a href="#ASSIGN_77">ASSIGN</a> x (<a href="#Var_e_17">Var_e</a> y))) (<a href="#ASSIGN_77">ASSIGN</a> y (<a href="#Var_e_17">Var_e</a> z))) s (<a href="fmap.html#add_65">add</a> y 5 (<a href="fmap.html#add_65">add</a> x 7 (<a href="fmap.html#add_65">add</a> z 5 s)))

  <span class="keyword">constant</span> <a name="y_148">y</a>: <a href="#var_7">var</a>
  <span class="keyword">constant</span> <a name="x_149">x</a>: <a href="#var_7">var</a>
  <span class="keyword">constant</span> <a name="z_150">z</a>: int

  <span class="keyword">axiom</span> <a name="z_ge_1_152">z_ge_1</a>:
    <a href="#z_150">z</a> <a href="int.html#infix%20%3E=_26">&gt;=</a> 1

  <span class="keyword">axiom</span> <a name="x_y_z_diff_155">x_y_z_diff</a>:
    <a href="#y_148">y</a> &lt;&gt; <a href="#x_149">x</a>

  <span class="keyword">constant</span> <a name="body_example_2_4_1_158">body_example_2_4_1</a>: <a href="#stm_76">stm</a> = (<a href="#COMP_79">COMP</a> (<a href="#ASSIGN_77">ASSIGN</a> <a href="#y_148">y</a> (<a href="#Op_e_19">Op_e</a> (<a href="#Var_e_17">Var_e</a> <a href="#y_148">y</a>) <a href="#MULT_12">MULT</a> (<a href="#Var_e_17">Var_e</a> <a href="#x_149">x</a>))) (<a href="#ASSIGN_77">ASSIGN</a> <a href="#x_149">x</a> (<a href="#Op_e_19">Op_e</a> (<a href="#Var_e_17">Var_e</a> <a href="#x_149">x</a>) <a href="#MINUS_13">MINUS</a> (<a href="#Int_e_16">Int_e</a> 1))))
  <span class="keyword">constant</span> <a name="while_example_2_4_1_159">while_example_2_4_1</a>: <a href="#stm_76">stm</a> = (<a href="#WHILE_81">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> (<a href="#B_aexp_e_57">B_aexp_e</a> (<a href="#Var_e_17">Var_e</a> <a href="#x_149">x</a>) <a href="#EQUAL_44">EQUAL</a> (<a href="#Int_e_16">Int_e</a> 1)))  <a href="#body_example_2_4_1_158">body_example_2_4_1</a>)
  <span class="keyword">constant</span> <a name="s0_160">s0</a>: <a href="#state_21">state</a>
  <span class="keyword">constant</span> <a name="s1_161">s1</a>:<a href="#state_21">state</a> = (<a href="fmap.html#add_65">add</a> <a href="#x_149">x</a> <a href="#z_150">z</a> <a href="#s0_160">s0</a>)
  <span class="keyword">constant</span> <a name="s2_162">s2</a>:<a href="#state_21">state</a> = (<a href="fmap.html#add_65">add</a> <a href="#y_148">y</a> ((<a href="fmap.html#find_83">find</a> <a href="#x_149">x</a> <a href="#s1_161">s1</a>) <a href="int.html#infix%20*_20">*</a> (<a href="fmap.html#find_83">find</a> <a href="#y_148">y</a> <a href="#s1_161">s1</a>)) <a href="#s1_161">s1</a>)
  <span class="keyword">constant</span> <a name="s3_163">s3</a>:<a href="#state_21">state</a> = (<a href="fmap.html#add_65">add</a> <a href="#x_149">x</a> ((<a href="fmap.html#find_83">find</a> <a href="#x_149">x</a> <a href="#s2_162">s2</a>) <a href="int.html#infix%20-_23">-</a> 1) <a href="#s2_162">s2</a>)

  <span class="keyword">lemma</span> <a name="example_2_4_1__165">example_2_4_1_</a>: <span class="keyword">forall</span> z s0.
    z <a href="int.html#infix%20%3E=_26">&gt;=</a>  1 -&gt;
      <span class="keyword">exists</span> s. (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> (<a href="#B_aexp_e_57">B_aexp_e</a> (<a href="#Var_e_17">Var_e</a> <a href="#x_149">x</a>) <a href="#EQUAL_44">EQUAL</a> (<a href="#Int_e_16">Int_e</a> 1)))  <a href="#body_example_2_4_1_158">body_example_2_4_1</a>) (<a href="fmap.html#add_65">add</a> <a href="#x_149">x</a> z s0) s

  <span class="keyword">lemma</span> <a name="lemma_2_5_170">lemma_2_5</a>: <span class="keyword">forall</span> b stm s s'.
    ((<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> b stm) s s') &lt;-&gt;
    ((<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#IF_80">IF</a> b (<a href="#COMP_79">COMP</a> stm (<a href="#WHILE_81">WHILE</a> b stm)) (<a href="#SKIP_78">SKIP</a>)) s s')

  <span class="keyword">lemma</span> <a name="exercise_2_6_174">exercise_2_6</a>: <span class="keyword">forall</span> stm1 stm2 stm3 s s'.
    (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#COMP_79">COMP</a> (stm1) (<a href="#COMP_79">COMP</a> stm2 stm3)) s s' &lt;-&gt;
    (<a href="#infix%20--%3E_107">--&gt;</a>) (<a href="#COMP_79">COMP</a> (<a href="#COMP_79">COMP</a> stm1 stm2) (stm3)) s s'

  <span class="keyword">lemma</span> <a name="theorem_2_9_deterministic_aux_179">theorem_2_9_deterministic_aux</a>:  <span class="keyword">forall</span> stm s s'.
    (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt;
    (<span class="keyword">forall</span> s''. (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s'' -&gt;
      s' = s'')

  <span class="keyword">lemma</span> <a name="theorem_2_9_deterministic_184">theorem_2_9_deterministic</a>:  <span class="keyword">forall</span> stm s s' s''.
    (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt;
      (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s'' -&gt;
        s' = s''

  <span class="keyword">inductive</span> (<a name="infix%20-%3E%3E_190">-&gt;&gt;</a>) <a href="#a_exp_15">a_exp</a> <a href="#state_21">state</a> int =
    | <a name="int_e_191">int_e</a> : <span class="keyword">forall</span> n s. (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Int_e_16">Int_e</a> n) s n
    | <a name="var_e_192">var_e</a> : <span class="keyword">forall</span> x s. (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Var_e_17">Var_e</a> x) s (<a href="fmap.html#find_83">find</a> x s)
    | <a name="minus_e_193">minus_e</a> : <span class="keyword">forall</span> x s v.
      (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) x s v -&gt;
       (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Minus_e_18">Minus_e</a> x) s (0 <a href="int.html#infix%20-_23">-</a> v)
    | <a name="plus_196">plus</a>  : <span class="keyword">forall</span> a1 a2 z1 z2 s.
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a1 s z1 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a2 s z2 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Op_e_19">Op_e</a> a1 <a href="#PLUS_11">PLUS</a> a2) s (z1 <a href="int.html#infix%20+_19">+</a> z2)
    | <a name="op_mult_200">op_mult</a>  : <span class="keyword">forall</span> a1 a2 z1 z2 s.
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a1 s z1 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a2 s z2 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Op_e_19">Op_e</a> a1 <a href="#MULT_12">MULT</a> a2) s (z1 <a href="int.html#infix%20*_20">*</a> z2)
    | <a name="op_minus_204">op_minus</a>  : <span class="keyword">forall</span> a1 a2 z1 z2 s.
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a1 s z1 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a2 s z2 -&gt;
                (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) (<a href="#Op_e_19">Op_e</a> a1 <a href="#MINUS_13">MINUS</a> a2) s (z1 <a href="int.html#infix%20-_23">-</a> z2)

  <span class="keyword">lemma</span> <a name="exercise_2_11_dir1_209">exercise_2_11_dir1</a>: <span class="keyword">forall</span> a s z.
    (<a href="#a_exp_eval_24">a_exp_eval</a> a s = z) -&gt; (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a s z

  <span class="keyword">lemma</span> <a name="exercise_2_11_dir2_212">exercise_2_11_dir2</a>: <span class="keyword">forall</span> a s z.
    (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a s z -&gt; (<a href="#a_exp_eval_24">a_exp_eval</a> a s = z)

  <span class="keyword">lemma</span> <a name="exercise_2_11_215">exercise_2_11</a>: <span class="keyword">forall</span> a s z.
    (<a href="#a_exp_eval_24">a_exp_eval</a> a s = z) &lt;-&gt; (<a href="#infix%20-%3E%3E_190">-&gt;&gt;</a>) a s z

  <span class="keyword">inductive</span> (<a name="infix%20-%3E%3E'_219">-&gt;&gt;</a>') <a href="#b_exp_55">b_exp</a> <a href="#state_21">state</a> bool =
    | <a name="b_e_220">b_e</a> : <span class="keyword">forall</span> b s. (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_e_56">B_e</a> b) s b
    | <a name="b_aexp_e_eq_true_221">b_aexp_e_eq_true</a> : <span class="keyword">forall</span> a1 a2 s.
                          <a href="#a_exp_eval_24">a_exp_eval</a> a1 s = <a href="#a_exp_eval_24">a_exp_eval</a> a2 s -&gt;
                          (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#EQUAL_44">EQUAL</a> a2) s True
    | <a name="b_aexp_e_eq_false_224">b_aexp_e_eq_false</a> : <span class="keyword">forall</span> a1 a2 s.
                          <span class="keyword">not</span> <a href="#a_exp_eval_24">a_exp_eval</a> a1 s = <a href="#a_exp_eval_24">a_exp_eval</a> a2 s -&gt;
                          (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#EQUAL_44">EQUAL</a> a2) s False
    | <a name="b_aexp_e_le_true_227">b_aexp_e_le_true</a> : <span class="keyword">forall</span> a1 a2 s.
                          <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s -&gt;
                          (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#LE_45">LE</a> a2) s True
    | <a name="b_aexp_e_le_false_230">b_aexp_e_le_false</a> : <span class="keyword">forall</span> a1 a2 s.
                          <span class="keyword">not</span> <a href="#a_exp_eval_24">a_exp_eval</a> a1 s <a href="int.html#infix%20%3C=_25">&lt;=</a> <a href="#a_exp_eval_24">a_exp_eval</a> a2 s -&gt;
                          (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_aexp_e_57">B_aexp_e</a> a1 <a href="#LE_45">LE</a> a2) s False
    | <a name="b_un_e_not_true_233">b_un_e_not_true</a> : <span class="keyword">forall</span> b s.
                        <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
                        (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) s True
    | <a name="b_un_e_not_false_236">b_un_e_not_false</a> : <span class="keyword">forall</span> b s.
                        <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
                        (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) s False
    | <a name="b_bin_e_true_239">b_bin_e_true</a>  : <span class="keyword">forall</span> b1 b2 s.
                      (<a href="#b_exp_eval_61">b_exp_eval</a> b1 s &amp;&amp; <a href="#b_exp_eval_61">b_exp_eval</a> b2 s) -&gt;
                      (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_bin_e_59">B_bin_e</a> b1 <a href="#AND_48">AND</a> b2) s True
    | <a name="b_bin_e_false_242">b_bin_e_false</a>  : <span class="keyword">forall</span> b1 b2 s.
                      <span class="keyword">not</span> (<a href="#b_exp_eval_61">b_exp_eval</a> b1 s &amp;&amp; <a href="#b_exp_eval_61">b_exp_eval</a> b2 s) -&gt;
                      (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') (<a href="#B_bin_e_59">B_bin_e</a> b1 <a href="#AND_48">AND</a> b2) s False

  <span class="keyword">lemma</span> <a name="exercise_2_12_dir1_247">exercise_2_12_dir1</a>: <span class="keyword">forall</span> b_exp s b.
    (<a href="#b_exp_eval_61">b_exp_eval</a> b_exp s = b) -&gt; (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') b_exp s b

  <span class="keyword">lemma</span> <a name="exercise_2_12_dir2_250">exercise_2_12_dir2</a>: <span class="keyword">forall</span> b_exp s b.
    (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') b_exp s b -&gt; (<a href="#b_exp_eval_61">b_exp_eval</a> b_exp s = b)

  <span class="keyword">lemma</span> <a name="exercise_2_12_253">exercise_2_12</a>: <span class="keyword">forall</span> b_exp s b.
    (<a href="#b_exp_eval_61">b_exp_eval</a> b_exp s = b) &lt;-&gt; (<a href="#infix%20-%3E%3E'_219">-&gt;&gt;</a>') b_exp s b

  <span class="keyword">function</span> <a name="ns_fun_257">ns_fun</a> (stm: <a href="#stm_76">stm</a>) (s: <a href="#state_21">state</a>) : <a href="#res_state_83">res_state</a>

  <span class="keyword">axiom</span> <a name="ns_fun_res_259">ns_fun_res</a>:
    <span class="keyword">forall</span> stm s s'.
      (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt; (<a href="#ns_fun_257">ns_fun</a> stm s = <a href="#Res_85">Res</a> s')

 <span class="keyword">axiom</span> <a name="ns_fun_undef_263">ns_fun_undef</a>:
    <span class="keyword">forall</span> stm s s'.
      <span class="keyword">not</span> (<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt; (<a href="#ns_fun_257">ns_fun</a> stm s = <a href="#Undef_84">Undef</a>)

  <span class="keyword">predicate</span> <a name="semantic_equivalent_268">semantic_equivalent</a> (stm1 stm2: <a href="#stm_76">stm</a>) (s: <a href="#state_21">state</a>)
   = <span class="keyword">forall</span> s'. ((<a href="#infix%20--%3E_107">--&gt;</a>) stm1 s s' -&gt; (<a href="#infix%20--%3E_107">--&gt;</a>) stm2 s s') &amp;&amp;
        ((<a href="#infix%20--%3E_107">--&gt;</a>) stm2 s s' -&gt; (<a href="#infix%20--%3E_107">--&gt;</a>) stm1 s s')

  <span class="keyword">lemma</span> <a name="exercise_2_13_dir1_272">exercise_2_13_dir1</a>:
    <span class="keyword">forall</span> stm1 stm2 s.
      (<a href="#semantic_equivalent_268">semantic_equivalent</a> stm1 stm2 s) -&gt; (<a href="#ns_fun_257">ns_fun</a> stm1 s = <a href="#ns_fun_257">ns_fun</a> stm2 s)

  <span class="keyword">lemma</span> <a name="exercise_2_13_dir2_276">exercise_2_13_dir2</a>:
    <span class="keyword">forall</span> stm1 stm2 s.
      (<a href="#ns_fun_257">ns_fun</a> stm1 s = <a href="#ns_fun_257">ns_fun</a> stm2 s) -&gt; (<a href="#semantic_equivalent_268">semantic_equivalent</a> stm1 stm2 s)

  <span class="keyword">lemma</span> <a name="exercise_2_13_280">exercise_2_13</a>:
    <span class="keyword">forall</span> stm1 stm2 s.
      (<a href="#ns_fun_257">ns_fun</a> stm1 s = <a href="#ns_fun_257">ns_fun</a> stm2 s) &lt;-&gt; (<a href="#semantic_equivalent_268">semantic_equivalent</a> stm1 stm2 s)

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Big_step_ext_">Big_step_ext</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#While_ext_">While_ext</a>

  <span class="keyword">inductive</span> (<a name="infix%20--%3E_291">--&gt;</a>) <a href="#stm_93">stm</a> <a href="#state_21">state</a> <a href="#state_21">state</a> =
    | <a name="ass_ns_292">ass_ns</a> : <span class="keyword">forall</span> x: <a href="#var_7">var</a>, a: <a href="#a_exp_15">a_exp</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#ASSIGN_94">ASSIGN</a> x a) s (<a href="fmap.html#add_65">add</a> x (<a href="#a_exp_eval_24">a_exp_eval</a> a s) s)
    | <a name="skip_ns_294">skip_ns</a> : <span class="keyword">forall</span> s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_291">--&gt;</a>) <a href="#SKIP_95">SKIP</a> s s
    | <a name="comp_ns_296">comp_ns</a> : <span class="keyword">forall</span> stm1 stm2: <a href="#stm_93">stm</a>, s s' s'': <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_291">--&gt;</a>) stm1 s s' -&gt;
            (<a href="#infix%20--%3E_291">--&gt;</a>) stm2 s' s'' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm1 stm2) s s''
    | <a name="if_tt_ns_300">if_tt_ns</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_93">stm</a>, s s': <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_291">--&gt;</a>) stm1 s s' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#IF_97">IF</a> b stm1 stm2) s s'
    | <a name="if_ff_ns_304">if_ff_ns</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_93">stm</a>, s s': <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_291">--&gt;</a>) stm2 s s' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#IF_97">IF</a> b stm1 stm2) s s'
    | <a name="while_tt_ns_308">while_tt_ns</a> : <span class="keyword">forall</span> b:<a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_93">stm</a>, s s' s'': <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_291">--&gt;</a>) stm s s' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#WHILE_98">WHILE</a> b stm) s' s'' -&gt;
                (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#WHILE_98">WHILE</a> b stm) s s''
    | <a name="while_ff_ns_313">while_ff_ns</a> : <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_93">stm</a>, s: <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
            (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#WHILE_98">WHILE</a> b stm) s s
    | <a name="repeat_tt_ns_316">repeat_tt_ns</a> : <span class="keyword">forall</span> b:<a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_93">stm</a>, s s': <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_291">--&gt;</a>) stm s s' -&gt;
            <a href="#b_exp_eval_61">b_exp_eval</a> b s' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s'
    | <a name="repeat_ff_ns_320">repeat_ff_ns</a> : <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_93">stm</a>, s s' s'': <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_291">--&gt;</a>) stm s s' -&gt;
            <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s' -&gt;
              (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s' s'' -&gt;
                (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s''

  <span class="keyword">lemma</span> <a name="exercise_2_7_dir1_327">exercise_2_7_dir1</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s' -&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#IF_97">IF</a> b <a href="#SKIP_95">SKIP</a> (<a href="#REPEAT_99">REPEAT</a> stm b))) s s'

  <span class="keyword">lemma</span> <a name="exercise_2_7_dir2_331">exercise_2_7_dir2</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#IF_97">IF</a> b <a href="#SKIP_95">SKIP</a> (<a href="#REPEAT_99">REPEAT</a> stm b))) s s' -&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s'

  <span class="keyword">lemma</span> <a name="exercise_2_7_335">exercise_2_7</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s' &lt;-&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#IF_97">IF</a> b <a href="#SKIP_95">SKIP</a> (<a href="#REPEAT_99">REPEAT</a> stm b))) s s'

  <span class="keyword">lemma</span> <a name="exercise_2_10_if_340">exercise_2_10_if</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s' -&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#WHILE_98">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) stm)) s s'

  <span class="keyword">lemma</span> <a name="exercise_2_10_onlyif_344">exercise_2_10_onlyif</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#WHILE_98">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) stm)) s s' -&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s'

  <span class="keyword">lemma</span> <a name="exercise_2_10_348">exercise_2_10</a>: <span class="keyword">forall</span> stm b s s'.
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s s' &lt;-&gt;
    (<a href="#infix%20--%3E_291">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm (<a href="#WHILE_98">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) stm)) s s'

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Small_step_">Small_step</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#While_">While</a>

  <span class="keyword">inductive</span> (<a name="infix%20--%3E_359">--&gt;</a>) <a href="#stm_76">stm</a> <a href="#state_21">state</a> <a href="#stm_76">stm</a> <a href="#state_21">state</a> =
    | <a name="ass_sos_360">ass_sos</a> : <span class="keyword">forall</span> x: <a href="#var_7">var</a>, a: <a href="#a_exp_15">a_exp</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#ASSIGN_77">ASSIGN</a> x a) s <a href="#SKIP_78">SKIP</a> (<a href="fmap.html#add_65">add</a> x (<a href="#a_exp_eval_24">a_exp_eval</a> a s) s)
    | <a name="comp0_sos_362">comp0_sos</a> : <span class="keyword">forall</span> stm2: <a href="#stm_76">stm</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#COMP_79">COMP</a> <a href="#SKIP_78">SKIP</a> stm2) s stm2 s
    | <a name="comp1_sos_364">comp1_sos</a> : <span class="keyword">forall</span> stm1 stm1' stm2: <a href="#stm_76">stm</a>, s s': <a href="#state_21">state</a>.
          stm1 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt;
            (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s stm1' s' -&gt;
                (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#COMP_79">COMP</a> stm1 stm2) s (<a href="#COMP_79">COMP</a> stm1' stm2) s'
    | <a name="if_tt_sos_368">if_tt_sos</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_76">stm</a>, s: <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
              (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#IF_80">IF</a> b stm1 stm2) s stm1 s
    | <a name="if_ff_sos_371">if_ff_sos</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_76">stm</a>, s: <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
              (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#IF_80">IF</a> b stm1 stm2) s stm2 s
    | <a name="while_sos_374">while_sos</a> : <span class="keyword">forall</span> b:<a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_76">stm</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#WHILE_81">WHILE</a> b stm) s (<a href="#IF_80">IF</a> b (<a href="#COMP_79">COMP</a> stm (<a href="#WHILE_81">WHILE</a> b stm)) <a href="#SKIP_78">SKIP</a>) s

  <span class="comment">(* transitivo *)</span>

  <span class="keyword">inductive</span> (<a name="infix%20--%3E*_380">--&gt;*</a>) <a href="#stm_76">stm</a> <a href="#state_21">state</a> <a href="#stm_76">stm</a> <a href="#state_21">state</a> =
    | <a name="BaseTrans_381">BaseTrans</a>: <span class="keyword">forall</span> stm1 s1 stm2 s2. (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2
    | <a name="StepTrans_382">StepTrans</a>: <span class="keyword">forall</span> stm1 stm2 stm3:<a href="#stm_76">stm</a>, s1 s2 s3:<a href="#state_21">state</a>.
            (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm3 s3

  <span class="comment">(* transitivo *)</span>

  <span class="keyword">lemma</span> <a name="ref_trans_389">ref_trans</a>:
    <span class="keyword">forall</span> stm1 stm2 stm3: <a href="#stm_76">stm</a>, s1 s2 s3: <a href="#state_21">state</a>.
            (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm3 s3

  <span class="keyword">inductive</span> (<a name="infix%20--%3E'_396">--&gt;</a>') int <a href="#stm_76">stm</a> <a href="#state_21">state</a> <a href="#stm_76">stm</a> <a href="#state_21">state</a> =
    | <a name="BaseIndex_397">BaseIndex</a>: <span class="keyword">forall</span> stm1 s1 stm2 s2. (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E'_396">--&gt;</a>') 1 stm1 s1 stm2 s2
    | <a name="StepIndex_398">StepIndex</a>: <span class="keyword">forall</span> stm1 stm2 stm3:<a href="#stm_76">stm</a>, s1 s2 s3:<a href="#state_21">state</a>, k.
            (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E_359">--&gt;</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E'_396">--&gt;</a>') (k<a href="int.html#infix%20+_19">+</a>1) stm1 s1 stm3 s3

  <span class="keyword">lemma</span> <a name="indexed_404">indexed</a>:
    <span class="keyword">forall</span> stm1 stm2: <a href="#stm_76">stm</a>, s1 s2: <a href="#state_21">state</a>, k1: int.
            (<a href="#infix%20--%3E'_396">--&gt;</a>') k1 stm1 s1 stm2 s2 -&gt;
              (<span class="keyword">forall</span> stm3,s3,k2. (<a href="#infix%20--%3E'_396">--&gt;</a>') k2 stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E'_396">--&gt;</a>') (k1<a href="int.html#infix%20+_19">+</a>k2) stm1 s1 stm3 s3)

  <span class="keyword">lemma</span> <a name="indexed_star_relation_410">indexed_star_relation</a>:
    <span class="keyword">forall</span> stm1 stm2 s1 s2 k.
      (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2

  <span class="keyword">predicate</span> <a name="semantic_equivalent_416">semantic_equivalent</a> (stm1 stm2: <a href="#stm_76">stm</a>) (s: <a href="#state_21">state</a>)
   = <span class="keyword">forall</span> s'. ((<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s <a href="#SKIP_78">SKIP</a> s' -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm2 s <a href="#SKIP_78">SKIP</a> s') &amp;&amp;
        ((<a href="#infix%20--%3E*_380">--&gt;*</a>) stm2 s <a href="#SKIP_78">SKIP</a> s' -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s <a href="#SKIP_78">SKIP</a> s')

  <span class="keyword">lemma</span> <a name="lemma_2_19_420">lemma_2_19</a>: <span class="keyword">forall</span> stm1 stm2 s s'' k.
            (<a href="#infix%20--%3E'_396">--&gt;</a>') k (<a href="#COMP_79">COMP</a> stm1 stm2) s <a href="#SKIP_78">SKIP</a> s'' -&gt;
             (<span class="keyword">exists</span> k1 k2 s'. (<a href="#infix%20--%3E'_396">--&gt;</a>') k1 stm1 s <a href="#SKIP_78">SKIP</a> s' -&gt;
                (<a href="#infix%20--%3E'_396">--&gt;</a>') k2 stm2 s' <a href="#SKIP_78">SKIP</a> s'' -&gt;
                  k1 <a href="int.html#infix%20+_19">+</a> k2 = k)

  <span class="keyword">lemma</span> <a name="star_implies_k_426">star_implies_k</a>: <span class="keyword">forall</span> stm1 stm2 s1 s2.
      (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2 -&gt; (<span class="keyword">exists</span> k. (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm1 s1 stm2 s2)

  <span class="keyword">lemma</span> <a name="exercise2_21_aux_430">exercise2_21_aux</a>: <span class="keyword">forall</span> stm1 stm1' s s' k.
    (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm1 s stm1' s' -&gt;
    (<span class="keyword">forall</span> stm2. (<a href="#infix%20--%3E'_396">--&gt;</a>') k (<a href="#COMP_79">COMP</a> stm1 stm2) s (<a href="#COMP_79">COMP</a> stm1' stm2) s')           
  
  
  <span class="keyword">lemma</span> <a name="exercise2_21_435">exercise2_21</a>: <span class="keyword">forall</span> stm1 s s' k.
    (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm1 s <a href="#SKIP_78">SKIP</a> s' -&gt;
    (<span class="keyword">forall</span> stm2. (<a href="#infix%20--%3E'_396">--&gt;</a>') k (<a href="#COMP_79">COMP</a> stm1 stm2) s (<a href="#COMP_79">COMP</a> <a href="#SKIP_78">SKIP</a> stm2) s')
   
    
  <span class="keyword">lemma</span> <a name="exercise2_22_aux_440">exercise2_22_aux</a>:
    <span class="keyword">forall</span> stm s stm' s'.
      (<a href="#infix%20--%3E_359">--&gt;</a>) stm s stm' s' -&gt;
        (<span class="keyword">forall</span> stm'' s''. (<a href="#infix%20--%3E_359">--&gt;</a>) stm s stm'' s'' -&gt;
          stm' = stm'' /\ s' = s'')

  <span class="keyword">lemma</span> <a name="exercise2_22_446">exercise2_22</a>:
    <span class="keyword">forall</span> stm s stm' s' stm'' s''.
      (<a href="#infix%20--%3E_359">--&gt;</a>) stm s stm' s' -&gt;
        (<a href="#infix%20--%3E_359">--&gt;</a>) stm s stm'' s'' -&gt;
          stm' = stm'' /\ s' = s''

  <span class="keyword">lemma</span> <a name="no_reduction_comp_skip_453">no_reduction_comp_skip</a>:
    <span class="keyword">forall</span> stm1 s1 stm2 s2. <span class="keyword">not</span> (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s1 stm2 s2 -&gt; <span class="keyword">not</span> (<a href="#infix%20--%3E_359">--&gt;</a>) (<a href="#COMP_79">COMP</a> stm1 <a href="#SKIP_78">SKIP</a>) s1 (<a href="#COMP_79">COMP</a> stm2 <a href="#SKIP_78">SKIP</a>) s2

  <span class="keyword">lemma</span> <a name="exercise2_23_1_dir1_456">exercise2_23_1_dir1</a>: <span class="keyword">forall</span> stm1.
    stm1 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt;
      (<span class="keyword">forall</span> s1 stm2 s2. stm2 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 <a href="#SKIP_78">SKIP</a>) s1 (<a href="#COMP_79">COMP</a> stm2 <a href="#SKIP_78">SKIP</a>) s2 -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2)

  <span class="keyword">lemma</span> <a name="exercise2_23_1_dir2_460">exercise2_23_1_dir2</a>: <span class="keyword">forall</span> stm1.
    stm1 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt;
      (<span class="keyword">forall</span> s1 stm2 s2. stm2 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 <a href="#SKIP_78">SKIP</a>) s1 (<a href="#COMP_79">COMP</a> stm2 <a href="#SKIP_78">SKIP</a>) s2)

  <span class="keyword">lemma</span> <a name="exercise2_23_1_464">exercise2_23_1</a>: <span class="keyword">forall</span> stm1 s1 stm2 s2.
    stm1 &lt;&gt; <a href="#SKIP_78">SKIP</a> /\ stm2 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt;
      (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 <a href="#SKIP_78">SKIP</a>) s1 (<a href="#COMP_79">COMP</a> stm2 <a href="#SKIP_78">SKIP</a>) s2 &lt;-&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s1 stm2 s2

  <span class="keyword">function</span> <a name="s_sos_fun_470">s_sos_fun</a> (statement: <a href="#stm_76">stm</a>) (state: <a href="#state_21">state</a>) : <a href="#res_state_83">res_state</a>

  <span class="keyword">axiom</span> <a name="sos_fun_res_472">sos_fun_res</a>:
    <span class="keyword">forall</span> stm s s'.
      (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm s <a href="#SKIP_78">SKIP</a> s' -&gt; (<a href="#s_sos_fun_470">s_sos_fun</a> stm s = <a href="#Res_85">Res</a> s')

  <span class="keyword">axiom</span> <a name="sos_fun_undef_476">sos_fun_undef</a>:
    <span class="keyword">forall</span> stm s s'.
      <span class="keyword">not</span> (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm s <a href="#SKIP_78">SKIP</a> s' -&gt; (<a href="#s_sos_fun_470">s_sos_fun</a> stm s = <a href="#Undef_84">Undef</a>)

  <span class="keyword">lemma</span> <a name="semantic_eq_amounts_to_481">semantic_eq_amounts_to</a>:
    <span class="keyword">forall</span> stm1 stm2 s.
      (<a href="#semantic_equivalent_416">semantic_equivalent</a> stm1 stm2 s) -&gt; (<a href="#s_sos_fun_470">s_sos_fun</a> stm1 s = <a href="#s_sos_fun_470">s_sos_fun</a> stm2 s)

  <span class="keyword">lemma</span> <a name="semantic_eq_amounts_to_other_dir_485">semantic_eq_amounts_to_other_dir</a>:
    <span class="keyword">forall</span> stm1 stm2 s.
      (<a href="#s_sos_fun_470">s_sos_fun</a> stm1 s = <a href="#s_sos_fun_470">s_sos_fun</a> stm2 s) -&gt; (<a href="#semantic_equivalent_416">semantic_equivalent</a> stm1 stm2 s)

   <span class="keyword">lemma</span> <a name="star_comp_aux_490">star_comp_aux</a>: <span class="keyword">forall</span> stm1 stm12 stm2 s s'.
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s stm12 s' -&gt;
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 stm2) s (<a href="#COMP_79">COMP</a> stm12 stm2) s'

   <span class="keyword">lemma</span> <a name="star_comp_494">star_comp</a>: <span class="keyword">forall</span> stm1 stm2 s s' s''.
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s <a href="#SKIP_78">SKIP</a> s' -&gt;
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm2 s' <a href="#SKIP_78">SKIP</a> s'' -&gt;
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 stm2) s <a href="#SKIP_78">SKIP</a> s''

   <span class="keyword">lemma</span> <a name="star_comp_skip_499">star_comp_skip</a>: <span class="keyword">forall</span> stm1 s s'.
     (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s <a href="#SKIP_78">SKIP</a> s' -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 <a href="#SKIP_78">SKIP</a>) s <a href="#SKIP_78">SKIP</a> s'

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Small_step_ext_">Small_step_ext</a>

  <span class="keyword">use</span> <span class="keyword">export</span> <a href="#While_ext_">While_ext</a>
  <span class="keyword">use</span> <a href="#Big_step_ext_">Big_step_ext</a> <span class="keyword">as</span> NAT

  <span class="keyword">inductive</span> (<a name="infix%20--%3E_509">--&gt;</a>) <a href="#stm_93">stm</a> <a href="#state_21">state</a> <a href="#stm_93">stm</a> <a href="#state_21">state</a> =
    | <a name="ass_sos_510">ass_sos</a> : <span class="keyword">forall</span> x: <a href="#var_7">var</a>, a: <a href="#a_exp_15">a_exp</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#ASSIGN_94">ASSIGN</a> x a) s <a href="#SKIP_95">SKIP</a> (<a href="fmap.html#add_65">add</a> x (<a href="#a_exp_eval_24">a_exp_eval</a> a s) s)
    | <a name="comp0_sos_512">comp0_sos</a> : <span class="keyword">forall</span> stm2: <a href="#stm_93">stm</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#COMP_96">COMP</a> <a href="#SKIP_95">SKIP</a> stm2) s stm2 s
    | <a name="comp1_sos_514">comp1_sos</a> : <span class="keyword">forall</span> stm1 stm1' stm2: <a href="#stm_93">stm</a>, s s': <a href="#state_21">state</a>.
          stm1 &lt;&gt; <a href="#SKIP_95">SKIP</a> -&gt;
            (<a href="#infix%20--%3E_509">--&gt;</a>) stm1 s stm1' s' -&gt;
                (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#COMP_96">COMP</a> stm1 stm2) s (<a href="#COMP_96">COMP</a> stm1' stm2) s'
    | <a name="if_tt_sos_518">if_tt_sos</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_93">stm</a>, s: <a href="#state_21">state</a>.
          <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
              (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#IF_97">IF</a> b stm1 stm2) s stm1 s
    | <a name="if_ff_sos_521">if_ff_sos</a>: <span class="keyword">forall</span> b: <a href="#b_exp_55">b_exp</a>, stm1 stm2: <a href="#stm_93">stm</a>, s: <a href="#state_21">state</a>.
          <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
              (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#IF_97">IF</a> b stm1 stm2) s stm2 s
    | <a name="while_sos_524">while_sos</a> : <span class="keyword">forall</span> b:<a href="#b_exp_55">b_exp</a>, stm: <a href="#stm_93">stm</a>, s: <a href="#state_21">state</a>.
          (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#WHILE_98">WHILE</a> b stm) s (<a href="#IF_97">IF</a> b (<a href="#COMP_96">COMP</a> stm (<a href="#WHILE_98">WHILE</a> b stm)) <a href="#SKIP_95">SKIP</a>) s
    | <a name="repeat_sos_526">repeat_sos</a>: <span class="keyword">forall</span> stm b s.
      (<a href="#infix%20--%3E_509">--&gt;</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s (<a href="#COMP_96">COMP</a> stm (<a href="#IF_97">IF</a> b <a href="#SKIP_95">SKIP</a> (<a href="#REPEAT_99">REPEAT</a> stm b))) s

  <span class="comment">(* ref e transitivo *)</span>

  <span class="keyword">inductive</span> (<a name="infix%20--%3E*_532">--&gt;*</a>) <a href="#stm_93">stm</a> <a href="#state_21">state</a> <a href="#stm_93">stm</a> <a href="#state_21">state</a> =
    | <a name="BaseTrans_533">BaseTrans</a>: <span class="keyword">forall</span> stm1 s1 stm2 s2. (<a href="#infix%20--%3E_509">--&gt;</a>) stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s1 stm2 s2
    | <a name="StepTrans_534">StepTrans</a>: <span class="keyword">forall</span> stm1 stm2 stm3:<a href="#stm_93">stm</a>, s1 s2 s3:<a href="#state_21">state</a>.
            (<a href="#infix%20--%3E_509">--&gt;</a>) stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s1 stm3 s3

  <span class="comment">(* transitivo *)</span>

  <span class="keyword">lemma</span> <a name="ref_trans_542">ref_trans</a>:
    <span class="keyword">forall</span> stm1 stm2 stm3: <a href="#stm_93">stm</a>, s1 s2 s3: <a href="#state_21">state</a>.
            (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s1 stm3 s3

  <span class="keyword">inductive</span> (<a name="infix%20--%3E'_549">--&gt;</a>') int <a href="#stm_93">stm</a> <a href="#state_21">state</a> <a href="#stm_93">stm</a> <a href="#state_21">state</a> =
    | <a name="BaseIndex_550">BaseIndex</a>: <span class="keyword">forall</span> stm1 s1 stm2 s2. (<a href="#infix%20--%3E_509">--&gt;</a>) stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E'_549">--&gt;</a>') 1 stm1 s1 stm2 s2
    | <a name="StepIndex_551">StepIndex</a>: <span class="keyword">forall</span> stm1 stm2 stm3:<a href="#stm_93">stm</a>, s1 s2 s3:<a href="#state_21">state</a>, k.
            (<a href="#infix%20--%3E'_549">--&gt;</a>') k stm1 s1 stm2 s2 -&gt;
              (<a href="#infix%20--%3E_509">--&gt;</a>) stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E'_549">--&gt;</a>') (k<a href="int.html#infix%20+_19">+</a>1) stm1 s1 stm3 s3

  <span class="keyword">lemma</span> <a name="indexed_557">indexed</a>:
    <span class="keyword">forall</span> stm1 stm2: <a href="#stm_93">stm</a>, s1 s2: <a href="#state_21">state</a>, k1: int.
            (<a href="#infix%20--%3E'_549">--&gt;</a>') k1 stm1 s1 stm2 s2 -&gt;
              (<span class="keyword">forall</span> stm3,s3,k2. (<a href="#infix%20--%3E'_549">--&gt;</a>') k2 stm2 s2 stm3 s3 -&gt;
                (<a href="#infix%20--%3E'_549">--&gt;</a>') (k1<a href="int.html#infix%20+_19">+</a>k2) stm1 s1 stm3 s3)

  <span class="keyword">lemma</span> <a name="indexed_star_relation_563">indexed_star_relation</a>:
    <span class="keyword">forall</span> stm1 stm2 s1 s2 k.
      (<a href="#infix%20--%3E'_549">--&gt;</a>') k stm1 s1 stm2 s2 -&gt; (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s1 stm2 s2

  <span class="keyword">predicate</span> <a name="semantic_equivalent_567">semantic_equivalent</a> (stm1 stm2: <a href="#stm_93">stm</a>) (s: <a href="#state_21">state</a>)
   = <span class="keyword">forall</span> s'. ((<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s <a href="#SKIP_95">SKIP</a> s' -&gt; (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm2 s <a href="#SKIP_95">SKIP</a> s') &amp;&amp;
        ((<a href="#infix%20--%3E*_532">--&gt;*</a>) stm2 s <a href="#SKIP_95">SKIP</a> s' -&gt; (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s <a href="#SKIP_95">SKIP</a> s')

  <span class="keyword">lemma</span> <a name="star_comp_571">star_comp</a>: <span class="keyword">forall</span> stm1 stm2 s s' s''.
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm1 s <a href="#SKIP_95">SKIP</a> s' -&gt;
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm2 s' <a href="#SKIP_95">SKIP</a> s'' -&gt;
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) (<a href="#COMP_96">COMP</a> stm1 stm2) s <a href="#SKIP_95">SKIP</a> s''

  <span class="keyword">lemma</span> <a name="star_comp_SKIP_576">star_comp_SKIP</a>: <span class="keyword">forall</span> stm s s'.
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm s <a href="#SKIP_95">SKIP</a> s' -&gt;
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) (<a href="#COMP_96">COMP</a> stm <a href="#SKIP_95">SKIP</a>) s <a href="#SKIP_95">SKIP</a> s'

  <span class="keyword">lemma</span> <a name="star_while_ff_580">star_while_ff</a>: <span class="keyword">forall</span> stm b s.
    <span class="keyword">not</span> <a href="#b_exp_eval_61">b_exp_eval</a> b s -&gt;
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) (<a href="#WHILE_98">WHILE</a> b stm) s <a href="#SKIP_95">SKIP</a> s

  <span class="keyword">lemma</span> <a name="star_repeat_tt_585">star_repeat_tt</a> : <span class="keyword">forall</span> b stm s s'.
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm s <a href="#SKIP_95">SKIP</a> s' -&gt;
    <a href="#b_exp_eval_61">b_exp_eval</a> b s' -&gt;
    (<a href="#infix%20--%3E*_532">--&gt;*</a>) (<a href="#REPEAT_99">REPEAT</a> stm b) s <a href="#SKIP_95">SKIP</a> s'

  <span class="keyword">lemma</span> <a name="star_SKIP_no_reduction_591">star_SKIP_no_reduction</a>: <span class="keyword">forall</span> stm2 s1 s2.
    <span class="keyword">not</span> (<a href="#infix%20--%3E*_532">--&gt;*</a>) <a href="#SKIP_95">SKIP</a> s1 stm2 s2

  <span class="keyword">lemma</span> <a name="star_big_step_relation_if_594">star_big_step_relation_if</a>: <span class="keyword">forall</span> stm.
   stm &lt;&gt; <a href="#SKIP_95">SKIP</a> -&gt;
   <span class="keyword">forall</span> s s'. NAT.(<a href="#infix%20--%3E_291">--&gt;</a>) stm s s' -&gt; (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm s <a href="#SKIP_95">SKIP</a> s'

  <span class="keyword">lemma</span> <a name="big_step_small_step_598">big_step_small_step</a>: <span class="keyword">forall</span> stm1 s stm2 s'.
    (<a href="#infix%20--%3E_509">--&gt;</a>) stm1 s stm2 s' -&gt;
    <span class="keyword">forall</span> s''. NAT.(<a href="#infix%20--%3E_291">--&gt;</a>) stm2 s' s'' -&gt;
    NAT.(<a href="#infix%20--%3E_291">--&gt;</a>) stm1 s s''

  <span class="keyword">lemma</span> <a name="star_big_step_relation_onlyif_603">star_big_step_relation_onlyif</a>: <span class="keyword">forall</span> stm s s'.
   (<a href="#infix%20--%3E*_532">--&gt;*</a>) stm s <a href="#SKIP_95">SKIP</a> s' -&gt;  NAT.(<a href="#infix%20--%3E_291">--&gt;</a>) stm s s'

  <span class="keyword">lemma</span> <a name="exercise2_24_606">exercise2_24</a>: <span class="keyword">forall</span> stm1 b s.
    <a href="#semantic_equivalent_567">semantic_equivalent</a> (<a href="#REPEAT_99">REPEAT</a> stm1 b)  (<a href="#COMP_96">COMP</a> stm1 (<a href="#WHILE_98">WHILE</a> (<a href="#B_un_e_58">B_un_e</a> <a href="#NOT_51">NOT</a> b) stm1)) s

<span class="keyword">end</span>

<span class="keyword">module</span> <a name="Results_between_small_big_step_">Results_between_small_big_step</a>

  <span class="comment">(* nat then finish in sos *)</span>
  <span class="keyword">use</span> <a href="#Small_step_">Small_step</a>
  <span class="keyword">use</span> <a href="#Big_step_">Big_step</a> <span class="keyword">as</span> NAT

  <span class="keyword">lemma</span> <a name="star_SKIP_no_reduction_618">star_SKIP_no_reduction</a>: <span class="keyword">forall</span> stm s1 s2.
      <span class="keyword">not</span> (<a href="#infix%20--%3E*_380">--&gt;*</a>) <a href="#SKIP_78">SKIP</a> s1 stm s2

  <span class="keyword">lemma</span> <a name="lemma_2_27_621">lemma_2_27</a>: <span class="keyword">forall</span> stm. stm &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt; (<span class="keyword">forall</span> s s'.
   NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm s s' -&gt; (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm s <a href="#SKIP_78">SKIP</a> s')

  <span class="keyword">lemma</span> <a name="head_step_big_step_relation_624">head_step_big_step_relation</a>: <span class="keyword">forall</span> stm s s'.
   (<a href="#infix%20--%3E_359">--&gt;</a>) stm s <a href="#SKIP_78">SKIP</a> s' -&gt; NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm s s'

  <span class="keyword">lemma</span> <a name="star_comp_627">star_comp</a>: <span class="keyword">forall</span> stm1 stm2 s s''.
      stm1 &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt;
        (<a href="#infix%20--%3E*_380">--&gt;*</a>) (<a href="#COMP_79">COMP</a> stm1 stm2) s <a href="#SKIP_78">SKIP</a> s'' -&gt;
          <span class="keyword">exists</span> s'. (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm1 s <a href="#SKIP_78">SKIP</a> s'

  <span class="keyword">lemma</span> <a name="big_step_small_step_632">big_step_small_step</a>: <span class="keyword">forall</span> stm1 s stm2 s'.
    (<a href="#infix%20--%3E_359">--&gt;</a>) stm1 s stm2 s' -&gt;
    <span class="keyword">forall</span> s''. NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm2 s' s'' -&gt;
    NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm1 s s''

  <span class="keyword">lemma</span> <a name="star_big_step_relation_637">star_big_step_relation</a>: <span class="keyword">forall</span> stm s s'.
   (<a href="#infix%20--%3E*_380">--&gt;*</a>) stm s <a href="#SKIP_78">SKIP</a> s' -&gt; NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm s s'

  <span class="keyword">lemma</span> <a name="lemma_2_28_640">lemma_2_28</a>: <span class="keyword">forall</span> stm:<a href="#stm_76">stm</a>, s:<a href="#state_21">state</a>, s':<a href="#state_21">state</a>, k:int.
    (<a href="#infix%20--%3E'_396">--&gt;</a>') k stm s <a href="#SKIP_78">SKIP</a> s' -&gt; NAT.(<a href="#infix%20--%3E_107">--&gt;</a>) stm s s'

  <span class="keyword">lemma</span> <a name="theorem_2_26_643">theorem_2_26</a>: <span class="keyword">forall</span> stm s.
    stm &lt;&gt; <a href="#SKIP_78">SKIP</a> -&gt; NAT.<a href="#ns_fun_257">ns_fun</a> stm s = <a href="#s_sos_fun_470">s_sos_fun</a> stm s

<span class="keyword">end</span></pre>

</div>
<hr>
<p>Generated by why3doc 1.4.0+git</p>
</body>
</html>
